<?php
/*
 * This file is part of the ************************ package.
 * _____________                           _______________
 *  ______/     \__  _____  ____  ______  / /_  _________
 *   ____/ __   / / / / _ \/ __`\/ / __ \/ __ \/ __ \___
 *    __/ / /  / /_/ /  __/ /  \  / /_/ / / / / /_/ /__
 *      \_\ \_/\____/\___/_/   / / .___/_/ /_/ .___/
 *         \_\                /_/_/         /_/
 *
 * The PHP Framework For Code Poem As Free As Wind. <Query Yet Simple>
 * (c) 2010-2018 http://queryphp.com All rights reserved.
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace Leevel\Option\Provider;

use Leevel\{
    Di\Provider,
    Option\Load,
    Option\Option
};

/**
 * option 服务提供者
 *
 * @author Xiangmin Liu <635750556@qq.com>
 * @package $$
 * @since 2017.05.12
 * @version 1.0
 */
class Register extends Provider
{

    /**
     * 注册服务
     *
     * @return void
     */
    public function register()
    {
        $this->option();
        $this->optionLoad();
    }

    /**
     * 可用服务提供者
     *
     * @return array
     */
    public static function providers()
    {
        return [
            'option' => [
                'Leevel\Option\Option',
                'Leevel\Option\IOption',
                'Qys\Option\Option',
                'Qys\Option\IOption'
            ],
            'load' => [
                'Leevel\Option\Load',
                'Qys\Option\Load'
            ]
        ];
    }

    /**
     * 注册 option 服务
     *
     * @return void
     */
    protected function option()
    {
        $this->singleton('option', function () {
            return new Option();
        });
    }

    /**
     * 注册 option.load 服务
     *
     * @return void
     */
    protected function optionLoad()
    {
        $this->singleton('option.load', function () {
            return new Load();
        });
    }
}
